(use-package desktop
  :init
  (desktop-save-mode t)
  (desktop-auto-save-enable)
  :config
  (setq desktop-dirname "~/.emacs.d/desktop-save/"
        desktop-save 'ask-if-new
        ;; don't save buffers, just the history
        desktop-files-not-to-save ""
        desktop-buffers-not-to-save "")
  (cl-loop for var in
    '(grep-history
      grep-find-history
      find-args-history
      extended-command-history
      read-expression-history
      default-input-method
      input-method-history
      query-replace-history
      compile-history
      string-rectangle-history
      regexp-history
      dired-shell-command-history
      dired-regexp-history
      shell-command-history
      org-tags-history
      minibuffer-history
      erc-server-history-list
      cp/activity-history
      LaTeX-environment-history
      swiper-history)
    do (add-to-list 'desktop-globals-to-save var)))

;; (add-to-list 'desktop-locals-to-save 'comint-input-ring)

(defun cp/backup-desktop-file ()
  (let ((new-filename (->> (shell-command-to-string "date -Is")
                           (replace-regexp-in-string "\n" "")
                           (concat "~/.emacs.d/.emacs.desktop."))))
    (copy-file "~/.emacs.d/.emacs.desktop" new-filename)))
(defun cp/cleanup-desktop-backups ()
  (let ((desktop-file-backups (-> (concat "find ~/.emacs.d/ -maxdepth 1 -type f |"
                                          " grep -E \"\.emacs\.desktop\.[0-9]{4}-[0-9]{2}-[0-9]{2}T[0-9]{2}:[0-9]{2}:[0-9]{2}[-+]?[0-9]{2}:?[0-9]{2}\"")
                                  (shell-command-to-string )) )))
  (if (> 10 )))
;; ;; this one created loads and loads of backups
;; (add-hook 'desktop-save-hook 'cp/backup-desktop-file)
;; ;; not enough space for this - wasteful
;; (add-hook 'kill-emacs-hook 'cp/backup-desktop-file)

(provide 'cp-desktop)
