(use-package elisp-mode
  :diminish
  :bind
  (:map emacs-lisp-mode-map
        ("<tab>" . 'company-indent-or-complete-common)
        ("<C-tab>" . 'outline-toggle-children)
        ("M-n" . 'outline-next-heading)
        ("M-p" . 'outline-previous-heading)
        ("M-m" . macrostep-expand))
  :config
  (put 'cl-loop 'lisp-indent-function 'defun)
  (setq print-length nil
        eval-expression-print-length nil))

(use-package eldoc
  :diminish
  :if (featurep 'elisp-mode)
  :init (add-hook 'emacs-lisp-mode-hook 'eldoc-mode)
  :config (setq eldoc-idle-delay 0))

(use-package emr
  :bind (:map prog-mode-map
              ("M-S-<return>" . emr-show-refactor-menu)))

(use-package nameless
  :commands nameless-mode
  :hook
  (ert-results-mode . nameless-mode)
  (emacs-lisp-mode . nameless-mode)
  :bind (:map emacs-lisp-mode-map
              ("C-c C-n" . nameless-mode)))

(use-package explain-pause-mode
  :load-path "/home/anon/.emacs.d/elisp-git/explain-pause-mode/"
  :disabled t
  :diminish
  :commands explain-pause-mode
  :init (explain-pause-mode))

(provide 'cp-prog-elisp)
